<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Under Water Drone: gnuplot_link.cpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Under Water Drone
   &#160;<span id="projectnumber">1.0</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',false,false,'search.php','Search');
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('gnuplot__link_8cpp_source.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<div class="header">
  <div class="headertitle">
<div class="title">gnuplot_link.cpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="gnuplot__link_8cpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#include &lt;fcntl.h&gt;</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#include &lt;sys/stat.h&gt;</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#include &lt;unistd.h&gt;</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160; </div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="preprocessor">#include &lt;cmath&gt;</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &lt;cstdio&gt;</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &lt;cstdlib&gt;</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#include &lt;cstring&gt;</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#include &lt;iostream&gt;</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &lt;sstream&gt;</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160; </div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#ifdef __GNUG__</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#pragma implementation</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160; </div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="gnuplot__link_8hh.html">gnuplot_link.hh</a>&quot;</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160; </div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="keyword">using namespace </span>std;</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160; </div>
<div class="line"><a name="l00020"></a><span class="lineno"><a class="line" href="gnuplot__link_8cpp.html#a436754f8938adb6375b530a1953f2d73">   20</a></span>&#160;<span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="gnuplot__link_8cpp.html#a436754f8938adb6375b530a1953f2d73">STDIN</a> = 0;</div>
<div class="line"><a name="l00021"></a><span class="lineno"><a class="line" href="gnuplot__link_8cpp.html#a1cb2ab4d1efcd28bda21b7a4eb2a5cee">   21</a></span>&#160;<span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="gnuplot__link_8cpp.html#a1cb2ab4d1efcd28bda21b7a4eb2a5cee">STDOUT</a> = 1;</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160; </div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespace_pz_g.html">PzG</a> {</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160; </div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;std::list&lt;FileInfo&gt; GnuplotLink::files_information_;</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160; </div>
<div class="line"><a name="l00027"></a><span class="lineno"><a class="line" href="class_pz_g_1_1_gnuplot_link.html#a9c8f23498ce784bd4f62583163e9c065">   27</a></span>&#160;<span class="keywordtype">void</span> GnuplotLink::ShowErrorMessages(<span class="keywordtype">bool</span> mode) {</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;    display_error_messages_ = mode;</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;}</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160; </div>
<div class="line"><a name="l00031"></a><span class="lineno"><a class="line" href="class_pz_g_1_1_gnuplot_link.html#adba8f71e0828a077757dae54918c0b45">   31</a></span>&#160;GnuplotLink::~GnuplotLink() {}</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160; </div>
<div class="line"><a name="l00033"></a><span class="lineno"><a class="line" href="class_pz_g_1_1_gnuplot_link.html#acf0c0bf937eb87f9c14dedf2f01780bc">   33</a></span>&#160;<span class="keywordtype">bool</span> GnuplotLink::SendToGnuplot(<span class="keyword">const</span> <span class="keywordtype">char</span> *command) {</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    <span class="keywordtype">int</span> string_length = strlen(command);</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    <span class="keywordtype">int</span> characters_sent;</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160; </div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    <span class="keywordflow">while</span> (((characters_sent = write(gnuplot_input_, command, string_length)) != -1) &amp;&amp; string_length &gt; 0) {</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;        command += characters_sent;</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;        string_length -= characters_sent;</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    }</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    <span class="keywordflow">if</span> (string_length &gt; 0) {</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;        ErrorMessage(<span class="stringliteral">&quot;!!! Przeslanie polecenia do GNUPlota nie powiodlo sie.&quot;</span>);</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    }</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;}</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160; </div>
<div class="line"><a name="l00048"></a><span class="lineno"><a class="line" href="class_pz_g_1_1_gnuplot_link.html#aa140852169cf67df9c565c33a45bff75">   48</a></span>&#160;GnuplotLink::GnuplotLink() {</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    show_OX_axis_ = show_OY_axis_ = show_OZ_axis_ = <span class="keyword">true</span>;</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160; </div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    drawing_mode_ = <a class="code" href="namespace_pz_g.html#a4360c76a1dbf714a19a0d97fe56e0660ac85b6f8146edb5ca2df8345dd86ef039">DM_2D</a>;</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    ShowErrorMessages();</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    gnuplot_output_ = gnuplot_input_ = -1;</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    SetRangeX(-350, 350);</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    SetRangeY(-350, 350);</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    SetRangeZ(-200, 250);</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    SetRotationXZ(60, 30);</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    SetScaleXZ(1, 1);</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;}</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160; </div>
<div class="line"><a name="l00061"></a><span class="lineno"><a class="line" href="namespace_pz_g.html#a64a72627607d0c3f47a61d19744eebef">   61</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="namespace_pz_g.html#a64a72627607d0c3f47a61d19744eebef">FileExists</a>(<span class="keywordtype">char</span> <span class="keyword">const</span> *filename) {</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;    <span class="keyword">struct </span>stat buf;</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160; </div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;    <span class="keywordflow">if</span> (stat(filename, &amp;buf)) <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;    <span class="keywordflow">if</span> (!(S_ISREG(buf.st_mode))) <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    <span class="keywordflow">if</span> (!(buf.st_mode &amp; S_IRUSR)) <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;    <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;}</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160; </div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;<span class="comment">//-------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;<span class="comment">// Powoduje dodanie do listy plikow zawierajacych dane dla gnuplota,</span></div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;<span class="comment">// nowej nazwy pliku.</span></div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;<span class="comment">//</span></div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;<span class="comment">// PRE:  filename  - nazwa pliku z danymi dla gnuplota.</span></div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;<span class="comment">// POST:</span></div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;<span class="comment">//  Zwraca wartosc:</span></div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;<span class="comment">//     true - jezeli istnieje plik o nazwie zawartej w zmiennej filename.</span></div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;<span class="comment">//             Zostaje on ponadto dodany do listy plikow z danymi</span></div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;<span class="comment">//             dla gnuplota.</span></div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;<span class="comment">//    fasle - Jezeli nie istnieje plik o nazwie zawartej w zmiennej</span></div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;<span class="comment">//            filename. Zadne dodatkowe dzialanie nie jest realizowane.</span></div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;<span class="comment">//</span></div>
<div class="line"><a name="l00083"></a><span class="lineno"><a class="line" href="class_pz_g_1_1_gnuplot_link.html#a795ee974694d79694496e09d668eb562">   83</a></span>&#160;<span class="keywordtype">bool</span> GnuplotLink::AddFilename(<span class="keyword">const</span> <span class="keywordtype">char</span> *filename,</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;                              <a class="code" href="namespace_pz_g.html#ab0580cdb6bfe9e51d7de2588bc824076">LineStyle</a> style,</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;                              <span class="keywordtype">int</span> width) {</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;    <span class="keywordtype">bool</span> result = <span class="keyword">true</span>;</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160; </div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;    <span class="keywordflow">if</span> (!<a class="code" href="namespace_pz_g.html#a64a72627607d0c3f47a61d19744eebef">FileExists</a>(filename)) {</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;        <span class="keywordtype">string</span> command = <span class="stringliteral">&quot;!!! Ostrzezenie: Brak pliku &quot;</span>;</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;        command += filename;</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;        <span class="comment">//TMP    ErrorMessage(command.c_str());</span></div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;        result = <span class="keyword">false</span>;</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;    }</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160; </div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;    files_information_.push_back(<a class="code" href="class_pz_g_1_1_file_info.html">FileInfo</a>(filename, style, width));</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;    <span class="keywordflow">return</span> result;</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;}</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160; </div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;<span class="comment">//-------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;<span class="comment">// Informuje, czy połączenie z programem gnuplot zostało zainicjowane.</span></div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;<span class="comment">//</span></div>
<div class="line"><a name="l00102"></a><span class="lineno"><a class="line" href="class_pz_g_1_1_gnuplot_link.html#a23e53f7a9d3ca945545f9292c55a7c96">  102</a></span>&#160;<span class="keywordtype">bool</span> GnuplotLink::IsConnectionInitialized()<span class="keyword"> const </span>{</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;    <span class="keywordflow">return</span> gnuplot_input_ &gt; -1 &amp;&amp; gnuplot_output_ &gt; -1;</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;}</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160; </div>
<div class="line"><a name="l00106"></a><span class="lineno"><a class="line" href="class_pz_g_1_1_gnuplot_link.html#a863bdb229a0d3e6d8d22cd5a4518d55e">  106</a></span>&#160;<span class="keywordtype">void</span> GnuplotLink::ErrorMessage(<span class="keyword">const</span> <span class="keywordtype">char</span> *command)<span class="keyword"> const </span>{</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;    <span class="keywordflow">if</span> (!AreErrorMessagesDisplayed()) <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;    cerr &lt;&lt; command &lt;&lt; endl;</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;}</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160; </div>
<div class="line"><a name="l00111"></a><span class="lineno"><a class="line" href="namespace_pz_g.html#a6d8d7783183a08d769e3c695cd35587f">  111</a></span>&#160;<span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="namespace_pz_g.html#a6d8d7783183a08d769e3c695cd35587f">LINE_LENGTH</a> = 120;</div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160; </div>
<div class="line"><a name="l00113"></a><span class="lineno"><a class="line" href="class_pz_g_1_1_gnuplot_link.html#a7f9c65c2319f35f1b7663ba0ad461d14">  113</a></span>&#160;<span class="keywordtype">bool</span> GnuplotLink::Init() {</div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;    <span class="keywordflow">if</span> (IsConnectionInitialized()) <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;    <span class="keywordflow">if</span> (!CreateChildProcess()) <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160; </div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;    <span class="keywordflow">return</span> SendToGnuplot(<span class="stringliteral">&quot;\n&quot;</span>);</div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;}</div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160; </div>
<div class="line"><a name="l00132"></a><span class="lineno"><a class="line" href="class_pz_g_1_1_gnuplot_link.html#a81a78898b39cb0b4c79ea4f3c90bbeb5">  132</a></span>&#160;<span class="keywordtype">bool</span> GnuplotLink::CreateChildProcess() {</div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;    <span class="keywordtype">int</span> input_descriptor[2], output_descriptor[2];</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160; </div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;    <span class="keywordflow">if</span> (pipe(input_descriptor) == -1 || pipe(output_descriptor) == -1) {</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;        ErrorMessage(</div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;            <span class="stringliteral">&quot;### Niemozliwe utworzenie kanalow komunikacyjnych do podprocesow.&quot;</span>);</div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;        exit(1);</div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;    }</div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160; </div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;    <span class="keywordflow">switch</span> (fork()) {</div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;        <span class="keywordflow">case</span> -1:</div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;            ErrorMessage(<span class="stringliteral">&quot;### Niemozliwe rozwidlenie procesu.&quot;</span>);</div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;            exit(1);</div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;        <span class="keywordflow">case</span> 0:</div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;            <span class="comment">/* Start potomka */</span></div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160; </div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;            <span class="keywordflow">if</span> (close(<a class="code" href="gnuplot__link_8cpp.html#a436754f8938adb6375b530a1953f2d73">STDIN</a>) == -1) {</div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;                ErrorMessage(<span class="stringliteral">&quot;### Blad przy zamykaniu strumienia wejsciowego.&quot;</span>);</div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;                exit(1);</div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;            }</div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;            <span class="keywordflow">if</span> (dup(output_descriptor[<a class="code" href="gnuplot__link_8cpp.html#a436754f8938adb6375b530a1953f2d73">STDIN</a>]) == -1) {</div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;                ErrorMessage(<span class="stringliteral">&quot;### Blad duplikacji kanalu wejsciowego.&quot;</span>);</div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;                exit(1);</div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;            }</div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160; </div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;            <span class="keywordflow">if</span> (close(<a class="code" href="gnuplot__link_8cpp.html#a1cb2ab4d1efcd28bda21b7a4eb2a5cee">STDOUT</a>) == -1) {</div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;                ErrorMessage(</div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;                    <span class="stringliteral">&quot;### Blad zamkniecia kanalu standardowego kanalu wyjsciowego.&quot;</span>);</div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;                exit(1);</div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;            }</div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;            <span class="keywordflow">if</span> (dup(input_descriptor[<a class="code" href="gnuplot__link_8cpp.html#a1cb2ab4d1efcd28bda21b7a4eb2a5cee">STDOUT</a>]) == -1) {</div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;                ErrorMessage(<span class="stringliteral">&quot;### Blad duplikacji kanalu wyjsciowego.&quot;</span>);</div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;                exit(1);</div>
<div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;            }</div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;            <span class="keywordflow">if</span> (close(output_descriptor[<a class="code" href="gnuplot__link_8cpp.html#a436754f8938adb6375b530a1953f2d73">STDIN</a>]) == -1) {</div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;                ErrorMessage(<span class="stringliteral">&quot;### Blad zamkniecia kanalu wejsciowego.&quot;</span>);</div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;                exit(1);</div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;            }</div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;            <span class="keywordflow">if</span> (close(output_descriptor[<a class="code" href="gnuplot__link_8cpp.html#a1cb2ab4d1efcd28bda21b7a4eb2a5cee">STDOUT</a>]) == -1) {</div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;                ErrorMessage(<span class="stringliteral">&quot;### Blad zamkniecia kanalu wyjsciowego.&quot;</span>);</div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;                exit(1);</div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;            }</div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;            <span class="keywordflow">if</span> (close(input_descriptor[<a class="code" href="gnuplot__link_8cpp.html#a436754f8938adb6375b530a1953f2d73">STDIN</a>]) == -1) {</div>
<div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;                ErrorMessage(<span class="stringliteral">&quot;### Blad zamkniecia duplikatu kanalu wejsciowego.&quot;</span>);</div>
<div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;                exit(1);</div>
<div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;            }</div>
<div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;            <span class="keywordflow">if</span> (close(input_descriptor[<a class="code" href="gnuplot__link_8cpp.html#a1cb2ab4d1efcd28bda21b7a4eb2a5cee">STDOUT</a>]) == -1) {</div>
<div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;                ErrorMessage(<span class="stringliteral">&quot;### Blad zamkniecia duplikatu kanalu wyjsciowego.&quot;</span>);</div>
<div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;                exit(1);</div>
<div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;            }</div>
<div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;            <span class="keywordtype">char</span> buffer[3];</div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;            read(<a class="code" href="gnuplot__link_8cpp.html#a436754f8938adb6375b530a1953f2d73">STDIN</a>, buffer, 1);</div>
<div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;            write(<a class="code" href="gnuplot__link_8cpp.html#a1cb2ab4d1efcd28bda21b7a4eb2a5cee">STDOUT</a>, <span class="stringliteral">&quot;\n&quot;</span>, 1);</div>
<div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;            <span class="keyword">const</span> <span class="keywordtype">char</span> *command;</div>
<div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160; </div>
<div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;            execlp(command = <span class="stringliteral">&quot;gnuplot&quot;</span>, <span class="stringliteral">&quot;gnuplot&quot;</span>, NULL);</div>
<div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160; </div>
<div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;            ErrorMessage(<span class="stringliteral">&quot;!!! Blad:&quot;</span>);</div>
<div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;            ErrorMessage(<span class="stringliteral">&quot;!!! W procesie potomnym nie mogl zostac.&quot;</span>);</div>
<div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;            ErrorMessage(<span class="stringliteral">&quot;!!! uruchomiony program gnuplot.&quot;</span>);</div>
<div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;            ErrorMessage(<span class="stringliteral">&quot;!!! Nastapilo przerwanie dzialania procesu potomnego.&quot;</span>);</div>
<div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;            ErrorMessage(<span class="stringliteral">&quot;!!! Jednym z mozliwych powodow problemu moze byc&quot;</span>);</div>
<div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;            ErrorMessage(<span class="stringliteral">&quot;!!! Brak programu gnuplot w szukanej sciezce.&quot;</span>);</div>
<div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;            ErrorMessage(<span class="stringliteral">&quot;!!! Do uruchomienia programu gnuplot bylo uzyte polecenie:&quot;</span>);</div>
<div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;            ErrorMessage(command);</div>
<div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;            exit(1);</div>
<div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160; </div>
<div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;        <span class="keywordflow">default</span>:</div>
<div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;            <span class="keywordflow">if</span> (close(output_descriptor[<a class="code" href="gnuplot__link_8cpp.html#a436754f8938adb6375b530a1953f2d73">STDIN</a>]) == -1 || close(input_descriptor[<a class="code" href="gnuplot__link_8cpp.html#a1cb2ab4d1efcd28bda21b7a4eb2a5cee">STDOUT</a>]) == -1) {</div>
<div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;                ErrorMessage(<span class="stringliteral">&quot; Blad zamkniecia outpipe[STDIN], inpipe[STDOUT].&quot;</span>);</div>
<div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;            }</div>
<div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160; </div>
<div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;            fcntl(input_descriptor[<a class="code" href="gnuplot__link_8cpp.html#a436754f8938adb6375b530a1953f2d73">STDIN</a>], F_SETFL, O_NDELAY);</div>
<div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;            gnuplot_output_ = input_descriptor[<a class="code" href="gnuplot__link_8cpp.html#a436754f8938adb6375b530a1953f2d73">STDIN</a>];</div>
<div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;            gnuplot_input_ = output_descriptor[<a class="code" href="gnuplot__link_8cpp.html#a1cb2ab4d1efcd28bda21b7a4eb2a5cee">STDOUT</a>];</div>
<div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;    }</div>
<div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;    <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;}</div>
<div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160; </div>
<div class="line"><a name="l00211"></a><span class="lineno"><a class="line" href="class_pz_g_1_1_gnuplot_link.html#a77b3776f569733b570681190b12d1891">  211</a></span>&#160;<span class="keywordtype">bool</span> GnuplotLink::DrawToFile(<span class="keyword">const</span> <span class="keywordtype">char</span> *filename) {</div>
<div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;    <span class="keywordflow">if</span> (!IsConnectionInitialized()) {</div>
<div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;        <span class="keywordflow">if</span> (!Init()) <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;    }</div>
<div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;    <span class="keywordtype">string</span> command = <span class="stringliteral">&quot;\n\n\nset output &#39;&quot;</span>;</div>
<div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;    command += filename;</div>
<div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;    command += <span class="stringliteral">&quot;\n set term png\n&quot;</span>;</div>
<div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;    <span class="keywordflow">if</span> (!SendToGnuplot(command.c_str())) {</div>
<div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;        ErrorMessage(<span class="stringliteral">&quot;!!! Rysunek nie moze byc utworzony.&quot;</span>);</div>
<div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;    }</div>
<div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160; </div>
<div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;    <span class="keywordtype">bool</span> result = Draw();</div>
<div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;    <span class="keywordflow">if</span> (!SendToGnuplot(<span class="stringliteral">&quot;\n\n\nset output \nset term x11\n&quot;</span>)) {</div>
<div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;        ErrorMessage(</div>
<div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;            <span class="stringliteral">&quot;!!! Wyjscie dla gnuplot&#39;a nie zostalo poprawnie\n&quot;</span></div>
<div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;            <span class="stringliteral">&quot;!!! przestawione na STDOUT.\n&quot;</span>);</div>
<div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;    }</div>
<div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;    <span class="keywordflow">return</span> result;</div>
<div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;}</div>
<div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160; </div>
<div class="line"><a name="l00252"></a><span class="lineno"><a class="line" href="class_pz_g_1_1_gnuplot_link.html#a8f6eb81e4b1324d338a13de9fe692583">  252</a></span>&#160;<span class="keywordtype">bool</span> GnuplotLink::AddDrawingFromFiles(std::string &amp;command,</div>
<div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;                                      <span class="keywordtype">char</span> <span class="keyword">const</span> **separator) {</div>
<div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;    <span class="keywordflow">if</span> (files_information_.empty()) <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;    list&lt;FileInfo&gt;::const_iterator names = files_information_.begin();</div>
<div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160; </div>
<div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;    <span class="keywordflow">for</span> (; names != files_information_.end(); ++names) {</div>
<div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;        <span class="comment">//       OSStrm.empty();</span></div>
<div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;        ostringstream OSStrm;</div>
<div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;        command += *separator;</div>
<div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;        command += <span class="stringliteral">&quot; \&#39;&quot;</span>;</div>
<div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;        command += names-&gt;GetFilename();</div>
<div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;        ((command += <span class="charliteral">&#39;\&#39;&#39;</span>) += <span class="stringliteral">&quot; notitle &quot;</span>) +=</div>
<div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;            (names-&gt;GetStyle() == <a class="code" href="namespace_pz_g.html#ab0580cdb6bfe9e51d7de2588bc824076af8f97c84dadf8eaa1f0370861e15dfec">LS_CONTINUOUS</a> ? <span class="stringliteral">&quot; w l&quot;</span> : <span class="stringliteral">&quot; w p pt 5&quot;</span>);</div>
<div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;        <span class="keywordflow">if</span> (names-&gt;GetStyle() == <a class="code" href="namespace_pz_g.html#ab0580cdb6bfe9e51d7de2588bc824076af8f97c84dadf8eaa1f0370861e15dfec">LS_CONTINUOUS</a>)</div>
<div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;            OSStrm &lt;&lt; <span class="stringliteral">&quot; lw &quot;</span> &lt;&lt; names-&gt;GetWidth();</div>
<div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;        <span class="keywordflow">else</span></div>
<div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;            OSStrm &lt;&lt; <span class="stringliteral">&quot; ps &quot;</span> &lt;&lt; names-&gt;GetWidth();</div>
<div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;        command += OSStrm.str();</div>
<div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;        *separator = <span class="stringliteral">&quot;, &quot;</span>;</div>
<div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;    }</div>
<div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;    <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;}</div>
<div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160; </div>
<div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;<span class="comment">//-------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;<span class="comment">//  Jezeli lista plikow nie jest pusta, to generuje sekwencje polecen</span></div>
<div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;<span class="comment">//  dla programu gnuplot majaca na celu narysowanie plaszczyzn na</span></div>
<div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160;<span class="comment">//  na podstawie danych zawartych w plikach z listy.</span></div>
<div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;<span class="comment">//</span></div>
<div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;<span class="comment">//  PRE:  Na liscie plikow nie powinna byc pusta. Nazwy plikow na niej</span></div>
<div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;<span class="comment">//        mozna umiescic za pomoca metody &#39;DodajNazwe&#39;.</span></div>
<div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160;<span class="comment">//        Metoda nie wymaga wcześniejszego zainicjowania połączenia</span></div>
<div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;<span class="comment">//        z gnuplotem.</span></div>
<div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;<span class="comment">//  POST: true   - gdy zostaja poprawnie wyslane polecenia dla gnuplota.</span></div>
<div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;<span class="comment">//                 Nie oznacza to jednak, ze proces rysowania zakończył</span></div>
<div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;<span class="comment">//                 się pomyślnie.</span></div>
<div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;<span class="comment">//       false   - gdy połączenie z gnuplotem nie moze zostac poprawnie</span></div>
<div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160;<span class="comment">//                 zainicjalizowane lub gdy lista plikow jest pusta.</span></div>
<div class="line"><a name="l00289"></a><span class="lineno">  289</span>&#160;<span class="comment">//</span></div>
<div class="line"><a name="l00290"></a><span class="lineno"><a class="line" href="class_pz_g_1_1_gnuplot_link.html#a96321ba10f7ee9c5f55dd17a28143a39">  290</a></span>&#160;<span class="keywordtype">bool</span> GnuplotLink::Draw() {</div>
<div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160;    <span class="keywordflow">if</span> (!IsConnectionInitialized()) {</div>
<div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160;        <span class="keywordflow">if</span> (!Init()) <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;    }</div>
<div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160; </div>
<div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;    <span class="keywordtype">string</span> command;</div>
<div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160; </div>
<div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;    CreateCommandPreamble(command);</div>
<div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160; </div>
<div class="line"><a name="l00299"></a><span class="lineno">  299</span>&#160;    <span class="keywordtype">char</span> <span class="keyword">const</span> *separator = <span class="stringliteral">&quot;&quot;</span>;</div>
<div class="line"><a name="l00300"></a><span class="lineno">  300</span>&#160;    <span class="keywordtype">bool</span> is_drawing_recommended = AddFilesToDrawCommand(command, &amp;separator);</div>
<div class="line"><a name="l00301"></a><span class="lineno">  301</span>&#160;    <span class="comment">/*</span></div>
<div class="line"><a name="l00302"></a><span class="lineno">  302</span>&#160;<span class="comment"></span> </div>
<div class="line"><a name="l00303"></a><span class="lineno">  303</span>&#160;<span class="comment">  */</span></div>
<div class="line"><a name="l00304"></a><span class="lineno">  304</span>&#160;    is_drawing_recommended = AddDrawingFromFiles(command, &amp;separator) || is_drawing_recommended;</div>
<div class="line"><a name="l00305"></a><span class="lineno">  305</span>&#160; </div>
<div class="line"><a name="l00306"></a><span class="lineno">  306</span>&#160;    <span class="keywordflow">if</span> (!is_drawing_recommended) <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00307"></a><span class="lineno">  307</span>&#160;    command += <span class="stringliteral">&quot;\npause -1\n&quot;</span>;</div>
<div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160;    <span class="keywordtype">string</span> command2 = <span class="stringliteral">&quot;/usr/bin/echo \&quot;&quot;</span>;</div>
<div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;    command2 += command;</div>
<div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160;    command2 += <span class="stringliteral">&quot;\&quot; | gnuplot&amp;&quot;</span>;</div>
<div class="line"><a name="l00311"></a><span class="lineno">  311</span>&#160; </div>
<div class="line"><a name="l00312"></a><span class="lineno">  312</span>&#160;    <span class="keywordflow">return</span> SendToGnuplot(command.c_str());</div>
<div class="line"><a name="l00313"></a><span class="lineno">  313</span>&#160;}</div>
<div class="line"><a name="l00314"></a><span class="lineno">  314</span>&#160; </div>
<div class="line"><a name="l00315"></a><span class="lineno"><a class="line" href="class_pz_g_1_1_gnuplot_link.html#aa2555a85839c555480c18da5015c0b26">  315</a></span>&#160;<span class="keywordtype">void</span> GnuplotLink::CreateCommandPreamble(std::string &amp;Preamble)<span class="keyword"> const </span>{</div>
<div class="line"><a name="l00316"></a><span class="lineno">  316</span>&#160;    <span class="keywordflow">switch</span> (drawing_mode_) {</div>
<div class="line"><a name="l00317"></a><span class="lineno">  317</span>&#160;        <span class="keywordflow">case</span> <a class="code" href="namespace_pz_g.html#a4360c76a1dbf714a19a0d97fe56e0660ac85b6f8146edb5ca2df8345dd86ef039">DM_2D</a>:</div>
<div class="line"><a name="l00318"></a><span class="lineno">  318</span>&#160;            Create2DPreamble(Preamble);</div>
<div class="line"><a name="l00319"></a><span class="lineno">  319</span>&#160;            <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160;        <span class="keywordflow">case</span> <a class="code" href="namespace_pz_g.html#a4360c76a1dbf714a19a0d97fe56e0660aa7ef207217913b87d83fdf559d8368c7">DM_3D</a>:</div>
<div class="line"><a name="l00321"></a><span class="lineno">  321</span>&#160;            Create3DPreamble(Preamble);</div>
<div class="line"><a name="l00322"></a><span class="lineno">  322</span>&#160;            <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00323"></a><span class="lineno">  323</span>&#160;    }</div>
<div class="line"><a name="l00324"></a><span class="lineno">  324</span>&#160;}</div>
<div class="line"><a name="l00325"></a><span class="lineno">  325</span>&#160; </div>
<div class="line"><a name="l00326"></a><span class="lineno"><a class="line" href="class_pz_g_1_1_gnuplot_link.html#a562fc970535935237a32f18faf4f0b19">  326</a></span>&#160;<span class="keywordtype">void</span> GnuplotLink::Create2DPreamble(std::string &amp;Preamble)<span class="keyword"> const </span>{</div>
<div class="line"><a name="l00327"></a><span class="lineno">  327</span>&#160;    Preamble.clear();</div>
<div class="line"><a name="l00328"></a><span class="lineno">  328</span>&#160;    Preamble.reserve(1000);</div>
<div class="line"><a name="l00329"></a><span class="lineno">  329</span>&#160;    Preamble = <span class="stringliteral">&quot;\n\n&quot;</span>;</div>
<div class="line"><a name="l00330"></a><span class="lineno">  330</span>&#160; </div>
<div class="line"><a name="l00331"></a><span class="lineno">  331</span>&#160;    <span class="keywordflow">if</span> (show_OX_axis_) Preamble += <span class="stringliteral">&quot;set xzeroaxis lt 0 lw 1\n&quot;</span>;</div>
<div class="line"><a name="l00332"></a><span class="lineno">  332</span>&#160;    <span class="keywordflow">if</span> (show_OY_axis_) Preamble += <span class="stringliteral">&quot;set yzeroaxis lt 0 lw 1\n&quot;</span>;</div>
<div class="line"><a name="l00333"></a><span class="lineno">  333</span>&#160; </div>
<div class="line"><a name="l00334"></a><span class="lineno">  334</span>&#160;    Preamble += SaveRangeSettings(<span class="charliteral">&#39;x&#39;</span>);</div>
<div class="line"><a name="l00335"></a><span class="lineno">  335</span>&#160;    Preamble += SaveRangeSettings(<span class="charliteral">&#39;y&#39;</span>);</div>
<div class="line"><a name="l00336"></a><span class="lineno">  336</span>&#160;    Preamble += <span class="stringliteral">&quot;\nplot &quot;</span>;</div>
<div class="line"><a name="l00337"></a><span class="lineno">  337</span>&#160;}</div>
<div class="line"><a name="l00338"></a><span class="lineno">  338</span>&#160; </div>
<div class="line"><a name="l00339"></a><span class="lineno"><a class="line" href="class_pz_g_1_1_gnuplot_link.html#a475373e9f4e3ea655a64e7daabd56ac9">  339</a></span>&#160;<span class="keywordtype">void</span> GnuplotLink::Create3DPreamble(std::string &amp;Preamble)<span class="keyword"> const </span>{</div>
<div class="line"><a name="l00340"></a><span class="lineno">  340</span>&#160;    Preamble.clear();</div>
<div class="line"><a name="l00341"></a><span class="lineno">  341</span>&#160;    Preamble.reserve(1000);</div>
<div class="line"><a name="l00342"></a><span class="lineno">  342</span>&#160;    Preamble =</div>
<div class="line"><a name="l00343"></a><span class="lineno">  343</span>&#160;        <span class="stringliteral">&quot;\n\n&quot;</span></div>
<div class="line"><a name="l00344"></a><span class="lineno">  344</span>&#160;        <span class="stringliteral">&quot;set parametric\n&quot;</span></div>
<div class="line"><a name="l00345"></a><span class="lineno">  345</span>&#160;        <span class="stringliteral">&quot;set isosamples 9\n&quot;</span></div>
<div class="line"><a name="l00346"></a><span class="lineno">  346</span>&#160;        <span class="stringliteral">&quot;set urange [-180:180]\n&quot;</span></div>
<div class="line"><a name="l00347"></a><span class="lineno">  347</span>&#160;        <span class="stringliteral">&quot;set vrange [-90:90]\n&quot;</span>;</div>
<div class="line"><a name="l00348"></a><span class="lineno">  348</span>&#160; </div>
<div class="line"><a name="l00349"></a><span class="lineno">  349</span>&#160;    <span class="keywordflow">if</span> (show_OX_axis_) Preamble += <span class="stringliteral">&quot;set xzeroaxis lt 0 lw 1\n&quot;</span>;</div>
<div class="line"><a name="l00350"></a><span class="lineno">  350</span>&#160;    <span class="keywordflow">if</span> (show_OY_axis_) Preamble += <span class="stringliteral">&quot;set yzeroaxis lt 0 lw 1\n&quot;</span>;</div>
<div class="line"><a name="l00351"></a><span class="lineno">  351</span>&#160;    <span class="keywordflow">if</span> (show_OZ_axis_) Preamble += <span class="stringliteral">&quot;set zzeroaxis lt 0 lw 1\n&quot;</span>;</div>
<div class="line"><a name="l00352"></a><span class="lineno">  352</span>&#160; </div>
<div class="line"><a name="l00353"></a><span class="lineno">  353</span>&#160;    Preamble += SaveRangeSettings(<span class="charliteral">&#39;x&#39;</span>);</div>
<div class="line"><a name="l00354"></a><span class="lineno">  354</span>&#160;    Preamble += SaveRangeSettings(<span class="charliteral">&#39;y&#39;</span>);</div>
<div class="line"><a name="l00355"></a><span class="lineno">  355</span>&#160;    Preamble += SaveRangeSettings(<span class="charliteral">&#39;z&#39;</span>);</div>
<div class="line"><a name="l00356"></a><span class="lineno">  356</span>&#160;    Preamble += SaveScaleRotationSettings();</div>
<div class="line"><a name="l00357"></a><span class="lineno">  357</span>&#160;    Preamble += <span class="stringliteral">&quot;set hidden3d\nsplot &quot;</span>;</div>
<div class="line"><a name="l00358"></a><span class="lineno">  358</span>&#160;}</div>
<div class="line"><a name="l00359"></a><span class="lineno">  359</span>&#160; </div>
<div class="line"><a name="l00360"></a><span class="lineno"><a class="line" href="class_pz_g_1_1_gnuplot_link.html#ab6bf77a1d62d351a2edb737c48d9353d">  360</a></span>&#160;std::string GnuplotLink::SaveRangeSettings(<span class="keywordtype">char</span> axis)<span class="keyword"> const </span>{</div>
<div class="line"><a name="l00361"></a><span class="lineno">  361</span>&#160;    ostringstream strm;</div>
<div class="line"><a name="l00362"></a><span class="lineno">  362</span>&#160;    <span class="keywordtype">float</span> Min, Max;</div>
<div class="line"><a name="l00363"></a><span class="lineno">  363</span>&#160; </div>
<div class="line"><a name="l00364"></a><span class="lineno">  364</span>&#160;    <span class="keywordflow">switch</span> (axis) {</div>
<div class="line"><a name="l00365"></a><span class="lineno">  365</span>&#160;        <span class="keywordflow">case</span> <span class="charliteral">&#39;x&#39;</span>:</div>
<div class="line"><a name="l00366"></a><span class="lineno">  366</span>&#160;            Min = Xmin();</div>
<div class="line"><a name="l00367"></a><span class="lineno">  367</span>&#160;            Max = Xmax();</div>
<div class="line"><a name="l00368"></a><span class="lineno">  368</span>&#160;            <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00369"></a><span class="lineno">  369</span>&#160;        <span class="keywordflow">case</span> <span class="charliteral">&#39;y&#39;</span>:</div>
<div class="line"><a name="l00370"></a><span class="lineno">  370</span>&#160;            Min = Ymin();</div>
<div class="line"><a name="l00371"></a><span class="lineno">  371</span>&#160;            Max = Ymax();</div>
<div class="line"><a name="l00372"></a><span class="lineno">  372</span>&#160;            <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00373"></a><span class="lineno">  373</span>&#160;        <span class="keywordflow">case</span> <span class="charliteral">&#39;z&#39;</span>:</div>
<div class="line"><a name="l00374"></a><span class="lineno">  374</span>&#160;            Min = Zmin();</div>
<div class="line"><a name="l00375"></a><span class="lineno">  375</span>&#160;            Max = Zmax();</div>
<div class="line"><a name="l00376"></a><span class="lineno">  376</span>&#160;            <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00377"></a><span class="lineno">  377</span>&#160;        <span class="keywordflow">default</span>:</div>
<div class="line"><a name="l00378"></a><span class="lineno">  378</span>&#160;            cerr &lt;&lt; <span class="stringliteral">&quot;!!! Blad w &#39;SaveRangeSettings&#39; niedozwolony znak: &quot;</span> &lt;&lt; axis &lt;&lt; endl;</div>
<div class="line"><a name="l00379"></a><span class="lineno">  379</span>&#160;            <span class="keywordflow">return</span> <span class="stringliteral">&quot;&quot;</span>;</div>
<div class="line"><a name="l00380"></a><span class="lineno">  380</span>&#160;    }</div>
<div class="line"><a name="l00381"></a><span class="lineno">  381</span>&#160;    strm &lt;&lt; <span class="stringliteral">&quot;set &quot;</span> &lt;&lt; axis &lt;&lt; <span class="stringliteral">&quot;range [&quot;</span> &lt;&lt; Min &lt;&lt; <span class="stringliteral">&quot;:&quot;</span> &lt;&lt; Max &lt;&lt; <span class="stringliteral">&quot;]\n&quot;</span>;</div>
<div class="line"><a name="l00382"></a><span class="lineno">  382</span>&#160;    <span class="keywordflow">return</span> strm.str();</div>
<div class="line"><a name="l00383"></a><span class="lineno">  383</span>&#160;}</div>
<div class="line"><a name="l00384"></a><span class="lineno">  384</span>&#160; </div>
<div class="line"><a name="l00385"></a><span class="lineno"><a class="line" href="class_pz_g_1_1_gnuplot_link.html#a8dccd32a85d0be08c6bd98b62281c743">  385</a></span>&#160;std::string GnuplotLink::SaveScaleRotationSettings()<span class="keyword"> const </span>{</div>
<div class="line"><a name="l00386"></a><span class="lineno">  386</span>&#160;    ostringstream strm;</div>
<div class="line"><a name="l00387"></a><span class="lineno">  387</span>&#160;    strm &lt;&lt; <span class="stringliteral">&quot;set view &quot;</span> &lt;&lt; RotationX() &lt;&lt; <span class="stringliteral">&quot;,&quot;</span> &lt;&lt; RotationZ()</div>
<div class="line"><a name="l00388"></a><span class="lineno">  388</span>&#160;         &lt;&lt; <span class="stringliteral">&quot;,&quot;</span> &lt;&lt; ScaleX() &lt;&lt; <span class="stringliteral">&quot;,&quot;</span> &lt;&lt; ScaleZ() &lt;&lt; endl;</div>
<div class="line"><a name="l00389"></a><span class="lineno">  389</span>&#160;    <span class="keywordflow">return</span> strm.str();</div>
<div class="line"><a name="l00390"></a><span class="lineno">  390</span>&#160;}</div>
<div class="line"><a name="l00391"></a><span class="lineno">  391</span>&#160; </div>
<div class="line"><a name="l00392"></a><span class="lineno">  392</span>&#160;<span class="comment">//-------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00393"></a><span class="lineno">  393</span>&#160;<span class="comment">//  Metda usuwa ostatnia nazwe z listy nazw plikow.</span></div>
<div class="line"><a name="l00394"></a><span class="lineno">  394</span>&#160;<span class="comment">//</span></div>
<div class="line"><a name="l00395"></a><span class="lineno"><a class="line" href="class_pz_g_1_1_gnuplot_link.html#acd96e1e3a99df66cfd68971f9974661f">  395</a></span>&#160;<span class="keywordtype">void</span> GnuplotLink::DeleteLastName() {</div>
<div class="line"><a name="l00396"></a><span class="lineno">  396</span>&#160;    list&lt;FileInfo&gt;::iterator names = files_information_.end();</div>
<div class="line"><a name="l00397"></a><span class="lineno">  397</span>&#160;    files_information_.erase(--names, files_information_.end());</div>
<div class="line"><a name="l00398"></a><span class="lineno">  398</span>&#160;}</div>
<div class="line"><a name="l00399"></a><span class="lineno">  399</span>&#160; </div>
<div class="line"><a name="l00400"></a><span class="lineno">  400</span>&#160;<span class="comment">//-------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00401"></a><span class="lineno">  401</span>&#160;<span class="comment">//  Metda calkowicie kasuje zawartosc listy nazw plikow.</span></div>
<div class="line"><a name="l00402"></a><span class="lineno">  402</span>&#160;<span class="comment">//</span></div>
<div class="line"><a name="l00403"></a><span class="lineno"><a class="line" href="class_pz_g_1_1_gnuplot_link.html#aa0e5912cf21d3e4ebaedfc4d473f1008">  403</a></span>&#160;<span class="keywordtype">void</span> GnuplotLink::DeleteAllNames() {</div>
<div class="line"><a name="l00404"></a><span class="lineno">  404</span>&#160;    files_information_.clear();</div>
<div class="line"><a name="l00405"></a><span class="lineno">  405</span>&#160;}</div>
<div class="line"><a name="l00406"></a><span class="lineno">  406</span>&#160; </div>
<div class="line"><a name="l00407"></a><span class="lineno">  407</span>&#160;}  <span class="comment">// namespace PzG</span></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<div class="ttc" id="anamespace_pz_g_html_ab0580cdb6bfe9e51d7de2588bc824076af8f97c84dadf8eaa1f0370861e15dfec"><div class="ttname"><a href="namespace_pz_g.html#ab0580cdb6bfe9e51d7de2588bc824076af8f97c84dadf8eaa1f0370861e15dfec">PzG::LS_CONTINUOUS</a></div><div class="ttdeci">@ LS_CONTINUOUS</div><div class="ttdef"><b>Definition:</b> <a href="gnuplot__link_8hh_source.html#l00048">gnuplot_link.hh:48</a></div></div>
<div class="ttc" id="anamespace_pz_g_html_a64a72627607d0c3f47a61d19744eebef"><div class="ttname"><a href="namespace_pz_g.html#a64a72627607d0c3f47a61d19744eebef">PzG::FileExists</a></div><div class="ttdeci">bool FileExists(char const *filename)</div><div class="ttdef"><b>Definition:</b> <a href="gnuplot__link_8cpp_source.html#l00061">gnuplot_link.cpp:61</a></div></div>
<div class="ttc" id="agnuplot__link_8cpp_html_a1cb2ab4d1efcd28bda21b7a4eb2a5cee"><div class="ttname"><a href="gnuplot__link_8cpp.html#a1cb2ab4d1efcd28bda21b7a4eb2a5cee">STDOUT</a></div><div class="ttdeci">const int STDOUT</div><div class="ttdef"><b>Definition:</b> <a href="gnuplot__link_8cpp_source.html#l00021">gnuplot_link.cpp:21</a></div></div>
<div class="ttc" id="anamespace_pz_g_html"><div class="ttname"><a href="namespace_pz_g.html">PzG</a></div><div class="ttdoc">Moduł narzędzi umożliwiających połącznie z GNUPlotem.</div><div class="ttdef"><b>Definition:</b> <a href="gnuplot__link_8hh_source.html#l00024">gnuplot_link.hh:24</a></div></div>
<div class="ttc" id="agnuplot__link_8cpp_html_a436754f8938adb6375b530a1953f2d73"><div class="ttname"><a href="gnuplot__link_8cpp.html#a436754f8938adb6375b530a1953f2d73">STDIN</a></div><div class="ttdeci">const int STDIN</div><div class="ttdef"><b>Definition:</b> <a href="gnuplot__link_8cpp_source.html#l00020">gnuplot_link.cpp:20</a></div></div>
<div class="ttc" id="anamespace_pz_g_html_a4360c76a1dbf714a19a0d97fe56e0660aa7ef207217913b87d83fdf559d8368c7"><div class="ttname"><a href="namespace_pz_g.html#a4360c76a1dbf714a19a0d97fe56e0660aa7ef207217913b87d83fdf559d8368c7">PzG::DM_3D</a></div><div class="ttdeci">@ DM_3D</div><div class="ttdef"><b>Definition:</b> <a href="gnuplot__link_8hh_source.html#l00042">gnuplot_link.hh:42</a></div></div>
<div class="ttc" id="aclass_pz_g_1_1_file_info_html"><div class="ttname"><a href="class_pz_g_1_1_file_info.html">PzG::FileInfo</a></div><div class="ttdoc">Zestaw informacji dotyczący pliku i sposobu rysowania.</div><div class="ttdef"><b>Definition:</b> <a href="gnuplot__link_8hh_source.html#l00057">gnuplot_link.hh:57</a></div></div>
<div class="ttc" id="anamespace_pz_g_html_a4360c76a1dbf714a19a0d97fe56e0660ac85b6f8146edb5ca2df8345dd86ef039"><div class="ttname"><a href="namespace_pz_g.html#a4360c76a1dbf714a19a0d97fe56e0660ac85b6f8146edb5ca2df8345dd86ef039">PzG::DM_2D</a></div><div class="ttdeci">@ DM_2D</div><div class="ttdef"><b>Definition:</b> <a href="gnuplot__link_8hh_source.html#l00041">gnuplot_link.hh:41</a></div></div>
<div class="ttc" id="agnuplot__link_8hh_html"><div class="ttname"><a href="gnuplot__link_8hh.html">gnuplot_link.hh</a></div></div>
<div class="ttc" id="anamespace_pz_g_html_a6d8d7783183a08d769e3c695cd35587f"><div class="ttname"><a href="namespace_pz_g.html#a6d8d7783183a08d769e3c695cd35587f">PzG::LINE_LENGTH</a></div><div class="ttdeci">const int LINE_LENGTH</div><div class="ttdef"><b>Definition:</b> <a href="gnuplot__link_8cpp_source.html#l00111">gnuplot_link.cpp:111</a></div></div>
<div class="ttc" id="anamespace_pz_g_html_ab0580cdb6bfe9e51d7de2588bc824076"><div class="ttname"><a href="namespace_pz_g.html#ab0580cdb6bfe9e51d7de2588bc824076">PzG::LineStyle</a></div><div class="ttdeci">LineStyle</div><div class="ttdoc">Sposób rysowania linii.</div><div class="ttdef"><b>Definition:</b> <a href="gnuplot__link_8hh_source.html#l00048">gnuplot_link.hh:48</a></div></div>
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_167790342fb55959539d550b874be046.html">project</a></li><li class="navelem"><a class="el" href="dir_f77a644fded742ea05ed17fa0fdf6fe1.html">src</a></li><li class="navelem"><a class="el" href="gnuplot__link_8cpp.html">gnuplot_link.cpp</a></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.17 </li>
  </ul>
</div>
</body>
</html>
